=== debian/changelog ===
ros-r2b2-test-rclcpp (0.0.2-0xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Dirk Thomas <dthomas@osrfoundation.org>  Sat, 01 Jul 2017 07:03:05 -0000
