=== debian/control ===
Source: ros-r2b2-test-rclcpp
Section: misc
Priority: extra
Maintainer: Dirk Thomas <dthomas@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), ros-r2b2-ament-cmake, ros-r2b2-ament-cmake-gtest, ros-r2b2-ament-cmake-nose, ros-r2b2-ament-lint-auto, ros-r2b2-ament-lint-common, ros-r2b2-launch, ros-r2b2-rclcpp, ros-r2b2-rmw-implementation, ros-r2b2-rmw-implementation-cmake, ros-r2b2-rosidl-default-generators, ros-r2b2-rosidl-default-runtime, ros-r2b2-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-r2b2-test-rclcpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-r2b2-ros-workspace
Description: Test rclcpp API.
 Each test is run with every available rmw implementation.
